import Block from './block'
import Channel from './channel'
import Council from './council'
import Proposal from './proposal'
import Member from './member'

import Category from './category'
import Thread from './thread'
import Post from './post'

Category.hasMany(Thread)
Category.belongsTo(Member, { as: 'moderator' })
Thread.belongsTo(Category)
Thread.belongsTo(Member, { as: 'author' })
Thread.hasMany(Post)
Post.belongsTo(Thread)
Post.belongsTo(Member, { as: 'author' })

export { Block, Channel, Council, Member, Proposal, Category, Thread, Post }
