import React from 'react'
import moment from 'moment'

import Blocks from './Blocks'
import Eras from './Eras'
import Council from './Council'
import Proposals from './Proposals'
import Validators from './Validators'
import Forum from './Forum'
import Footer from './Footer'

const Main = (props) => {
  const { showValidator, blocks, timestamp } = props

  return (
    <div className="w-100 h-100 d-flex flex-column overflow-hidden bg-dark">
      <div className="h-100 flex-grow-1 d-flex flex-row justify-content-between">
        <div className="h-100 col-4 p-3 text-light overflow-hidden">
          <Blocks
            showValidator={showValidator}
            blocks={blocks}
            timestamp={timestamp}
          />
        </div>
        <div className="col-4 d-flex flex-column text-center">
          <Eras blocks={blocks} />
        </div>
        <div className="col-4 d-flex flex-column text-center">
          <Validators showValidator={showValidator} blocks={blocks} />
        </div>
      </div>
      <Footer />
    </div>
  )
}

export default Main

//<Council />
//<Proposals />
//<Forum />
